// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];

var snridMBTemperature1 =      (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridCPUTemperature1 =     (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0200;

var snridVcoreVoltage =        (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;

var snridFan1Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0110;
var snridFan2Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0130;
var snridFan3Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0140;
var snridFan4Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0150;
var snridFan5Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0170;


var compPCI = new SysComponentInfo ('PCI', "parent.I18N['EXPANDSLOTS']", 'info_pci1.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 3, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 3, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 3, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 4, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 4, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 4, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 5, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 5, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 5, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 5, 7).extra", snsridHasDMI)
    )
);
var compFan1 = new SysComponentInfo ('FAN1', "parent.once.GSensorNames[parent.once.snridFan1Speed]", 'info_cpufan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan1Speed).unit]", snridFan1Speed)
    )
);
var compFan2 = new SysComponentInfo ('FAN2', "parent.once.GSensorNames[parent.once.snridFan2Speed]", 'info_frontfan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan2Speed).unit]", snridFan2Speed)
    )
);
var compFan3 = new SysComponentInfo ('FAN3', "parent.once.GSensorNames[parent.once.snridFan3Speed]", 'info_frontfan2.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan3Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan3Speed).unit]", snridFan3Speed)
    )
);
var compFan4 = new SysComponentInfo ('FAN4', "parent.once.GSensorNames[parent.once.snridFan4Speed]", 'info_frontfan3.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan4Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan4Speed).unit]", snridFan4Speed)
    )
);
var compFan5 = new SysComponentInfo ('FAN5', "parent.once.GSensorNames[parent.once.snridFan5Speed]", 'info_rearfan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan5Speed).unit]", snridFan5Speed)
    )
);

var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_winbond.jpg',
    new Tuple (
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature1]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature1).unit]", snridMBTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature1]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).unit]", snridCPUTemperature1)
    )
);

var compMemory;
if (parent.once.hasNewSmBiosMemFeature) {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr1.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 8).value)", snsridHasDMI)
        )
    );
} else {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr1.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI)
        )
    );
}

var compCPU = new SysComponentInfo ('CPU1', "parent.I18N['CPU'] + ' 1'", 'info_cpu1.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcoreVoltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature1]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).unit]", snridCPUTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridVcoreVoltage]", "parent.once.GSensors.idAt(parent.once.snridVcoreVoltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcoreVoltage).unit]", snridVcoreVoltage)
    )
);

var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "4"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);


var theSystemComponents = new Tuple (
    compIOConnector,
    compFan1,
    compFan2,
    compFan3,
    compFan4,
    compFan5,
    compMotherboard,
    compMemory,
    compPCI,
    compCPU
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/p5m2-e_4l/';
var theSystem = new SysModel ('model.jpg', chassis_tower);
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect (235, 194, 251, 205), compMotherboard),
            new AnArea (new Rect (255, 152, 264, 163), compFan1),
            new AnArea (new Rect (255, 180, 264, 191), compFan2),
            new AnArea (new Rect ( 59, 202,  70, 211), compFan3),
            new AnArea (new Rect ( 45, 202,  56, 211), compFan4),
            new AnArea (new Rect (189,  42, 198,  53), compFan5),
            new AnArea (new Rect ( 37,  46, 125, 123), compPCI),
            new AnArea (new Rect (132, 156, 254, 193), compMemory),
            new AnArea (new Rect (206,  76, 242, 123), compCPU)
        ),
        new Tuple (
            new quadruple ('AL_FAN1', parent.asID['IDV_TYPE_SNR'], snridFan1Speed, new Point (250, 149)),
            new quadruple ('AL_FAN2', parent.asID['IDV_TYPE_SNR'], snridFan2Speed, new Point (250, 177)),
            new quadruple ('AL_FAN3', parent.asID['IDV_TYPE_SNR'], snridFan3Speed, new Point (55, 198)),
            new quadruple ('AL_FAN4', parent.asID['IDV_TYPE_SNR'], snridFan4Speed, new Point (42, 198)),
            new quadruple ('AL_FAN5', parent.asID['IDV_TYPE_SNR'], snridFan5Speed, new Point (184, 39)),
            new quadruple ('AL_CPU1TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPUTemperature1, new Point (215, 91)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcoreVoltage, new Point (215, 91)),
            new quadruple ('AL_MBTEMP1', parent.asID['IDV_TYPE_SNR'], snridMBTemperature1, new Point (234, 191))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas (
            new AnArea (new Rect (  20,  94, 151, 122), compIOConnector)
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "4",
        "parent.I18N['USB_PORT']", "2"
    )
);

